#version 130
precision highp float;

const float Tau = 0.5f;


uniform sampler2D lastAdaptedLumTexture;
uniform sampler2D curLumTexture;
uniform float frameTime;

//in vec2 frag_texCoord;

out vec4 fragColor;



// CalcAdaptedLumPS
void main()
{
	float lastAdaptedLum = texture2D(lastAdaptedLumTexture, vec2(0.5f, 0.5f)).r;
	float curLum = texture2D(curLumTexture, vec2(0.5f, 0.5f)).r;

	// Adapt the luminance using Pattanaik's technique
	float adaptedLum = lastAdaptedLum + (curLum - lastAdaptedLum) * (1 - exp(-frameTime * Tau));

	fragColor = vec4(adaptedLum, 1.0f, 1.0f, 1.0f);
}