#version 130
precision highp float;

uniform sampler2D colorTexture;
uniform sampler2D depthTexture;
uniform bool copyColor;
uniform bool copyDepth;
uniform bool copyColorByAlpha;

uniform bool merge2Tex;
uniform float weighTex;
uniform float weighTex2;
uniform sampler2D colorTexture2;


in vec2 frag_texCoord;

out vec4 fragColor;


void main()
{
	if(merge2Tex)
	{
		fragColor = (texture2D(colorTexture, frag_texCoord) * weighTex + texture2D(colorTexture2, frag_texCoord) * weighTex2) / 2.0f;
	}
	else
	{
		if(copyDepth)
		{
			float depth = (texture2D(depthTexture, frag_texCoord)).r;
			gl_FragDepth = depth;
		}
		else
		{
			gl_FragDepth = 1.0f; // Farplan
		}
		
		if(copyColor)
		{
			fragColor = texture2D(colorTexture, frag_texCoord);
			/*if(useGammer)
			{
				fragColor *= gammer;
			}*/
			
			if(copyColorByAlpha)
			{
				fragColor = vec4(fragColor.rgb * fragColor.a, fragColor.a);
			}
		}
		else // farben mit kopieren
		{
			fragColor = vec4(0.0f, 0.0f, 0.0f, 0.0f);
			/*
			// vidualisiere die depth map
			//float depth = (textureOffset(depthTexture, frag_texCoord, ivec2(-2, 2))).r;
			float depthVisual = depth*20.0f - 19.2f;
			fragColor = vec4(depthVisual, depthVisual, depthVisual, 1.0f);
			*/
		}
	}
	
	
}