#version 130
precision highp float;

// # de fi ne LOOP_TIME 5.0
#define YELLOW vec4(1.0f, 1.0f, 0.0f, 0.0f)

uniform mat4 persp;
uniform mat4 camera;
uniform float curTime;
uniform float frameTime;
uniform float maxStartRadius;

in vec3 curPos; // wordspace
in vec3 shipVelosity;
//in float startRadius;
//in float startWinkel;
in vec2 startPos;
//in mat3 shipRotate;
in vec3 shipRotate0;
in vec3 shipRotate1;
in vec3 shipRotate2;
in float startTime;
in float startTimeOffset;
in float lifeTime;
in vec3 curParticleVelosity;
in vec3 lastParticleVelosity;
in vec4 color;

out vec4 vertColor;


vec4 getStartPos()
{
	mat3 shipRotate = mat3(shipRotate0, shipRotate1, shipRotate2);
	
	//float x = cos(startWinkel) * startRadius;
	//float y = sin(startWinkel) * startRadius;

	//vec3 startPos = shipRotate * vec3(x, y, 0.0f);
	vec3 startPos3 = shipRotate * vec3(startPos, 0.0f);
	startPos3 = startPos3 + curPos;
	
	// so tun als wehren kontinuirlich particle wehrend dises und des letztem frams entstanden
	startPos3 = startPos3 + (shipVelosity * startTimeOffset/frameTime);

	return vec4(startPos3, 1.0f);
}

float getRadius()
{
	return sqrt(pow(startPos.x, 2) + pow(startPos.y, 2));
}

vec3 getVelosity()
{
	vec3 velosityDifference = curParticleVelosity - lastParticleVelosity;
	return curParticleVelosity + (velosityDifference * startTimeOffset/frameTime); // velosity vektor so interpolieren das er zum time offset passt (particel continuirlich abfeuern und nicht zu bestimmten frams)
}

void main()
{	
	float realStartTime = startTime + startTimeOffset;
	if(curTime < realStartTime + lifeTime)
	{	
		
		float timeSinceStart = curTime - realStartTime;
		vec4 particleMove =  vec4(getVelosity() * timeSinceStart, 0.0f);
		vec4 newVertex = getStartPos() + particleMove;
		gl_Position = persp * camera * newVertex;
		vec4 fire_color = color + YELLOW * (1.0f - getRadius() / maxStartRadius) * 03.5f; // seto weiter innen desto mehr weis dazu
		vertColor = fire_color * max((realStartTime - curTime + lifeTime) / lifeTime, 0.0f);
	}
	else
	{
		gl_Position = vec4(0.0f, 0.0f, -10.0f, 1.0f); // hinter die kamera setzen
		vertColor = vec4(0.0f, 0.0f, 0.0f, 0.0f); // einfach nichts ausgeben
	}
}